<template>
  <zj-tab-page ref="tabPage" :defaultActives="[{ key: 'list', label: $route.meta.title + '-列表', essential: true }]">
    <template slot-scope="{ activeKey, data }">
      <template-page
        v-if="activeKey == 'list'"
        ref="pageRef"
        :get-list="getList"
        :table-attributes="tableAttributes"
        :table-events="tableEvents"
        :options-evens-group="optionsEvensGroup"
        :moreParameters="moreParameters"
        :column-parsing="columnParsing"
        :operation="operation()"
        :exportList="exportList"
        :operationColumnWidth="80"
      >
      </template-page>
      <div v-if="~['add', 'edit'].indexOf(activeKey)">
        <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
          <zj-form-module
            title=""
            label-width="120px"
            :showPackUp="false"
            :form-data="formData"
            :form-items="formItems"
          >
          </zj-form-module>
        </zj-form-container>
        <div slot="footer" class="dialog-footer">
          <el-button size="mini" @click="data.removeTab()">取 消</el-button>
          <el-button size="mini" @click="formConfirm(data.removeTab)" type="primary">确 定</el-button>
        </div>
      </div>
    </template>
  </zj-tab-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import {
  websitGoodsAloneMList,
  websitGoodsAloneMListExport,
  websitGoodsAloneDetail,
  websitGoodsAloneAdd,
  websitGoodsAloneEdit,
  websitGoodsAloneMImport,
  websitGoodsAloneBatchUpdateStatus
} from '@/api/auxiliaryMaterialBasicInfo.js'
import { getTypeList } from '@/api/auxiliaryFittings/attachmentProfile'
import { commonTemplateDownload } from '@/api/common.js'
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage },
  mixins: [import_mixin, operation_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: true
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ['新增', '编辑'],
      formDialog: false,
      formData: {
        companyWechatName: JSON.parse(localStorage.getItem('greemall_user')).companyName,
        convertBitScale: '',
        cost: '',
        createBy: '',
        createTime: '',
        goodsBarcodeId: '',
        categoryName: '',
        goodsCode: '',
        goodsId: '',
        goodsImage: '',
        goodsName: '',
        goodsSalesConvertQty: '',
        goodsSalesUnit: '',
        goodsSpecification: '',
        goodsSpell: '',
        goodsStockUnit: '',
        goodsType: 'M',
        manageWorkerStock: '',
        marketPrice: '',
        normAmount: '',
        normType: '',
        outWebsitAmount: '',
        outWorkerAmount: '',
        parentCategoryId: '',
        remark: '',
        selfWebsitAmount: '',
        selfWorkerAmount: '',
        status: 'ON'
      },
      partsUnitList: [],
      formType: 'add',
      formVisible: false
    }
  },
  computed: {
    // 事件组合
    optionsEvensGroup() {
      return [
        [
          [
            this.optionsEvensAuth('add', {
              click: () => {
                this.openForm('add')
              }
            })
          ],
          [
            this.optionsEvensAuth(['imp', 'template'], {
              name: '导入辅材',
              click: () => {}
            }),
            this.optionsEvensAuth('imp', ({ moduleName }) => {
              return {
                name: moduleName,
                render: () => {
                  return this.importButton(websitGoodsAloneMImport, moduleName)
                }
              }
            }),
            this.optionsEvensAuth('template', {
              click: () => {
                commonTemplateDownload({ name: '开单辅材模板.xlsx' }, `开单辅材模板`)
                  .then(res => {
                    this.$message({
                      message: '下载成功',
                      type: 'success'
                    })
                  })
                  .catch(err => {
                    this.$message.error('下载失败')
                  })
              }
            })
          ]
        ],
        [
          [
            this.optionsEvensAuth('batchLaunch', {
              click: () => {
                if (this.recordSelected.length) {
                  this.setRowStatus('ON')
                } else {
                  this.$message({
                    type: 'warning',
                    message: `请先勾选需要设置的数据！`
                  })
                }
              }
            })
          ],
          [
            this.optionsEvensAuth('batchRemoval', {
              click: () => {
                if (this.recordSelected.length) {
                  this.setRowStatus('OFF')
                } else {
                  this.$message({
                    type: 'warning',
                    message: `请先勾选需要设置的数据！`
                  })
                }
              }
            })
          ]
        ]
      ]
    },
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [
        {
          md: 6,
          isShow: true,
          name: 'el-radio',
          options: [
            { label: '上架', value: 'ON' },
            { label: '下架', value: 'OFF' }
          ],
          attributes: {},
          formItemAttributes: {
            label: '状态',
            prop: 'status',
            rules: [...required]
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '选择分类',
            prop: 'categoryName',
            rules: [...required]
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '辅材名称',
            prop: 'goodsName',
            rules: [...required]
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-select-add',
          labelKey: 'dictValue',
          valueKey: 'dictValue',
          options: this.partsUnitList,
          attributes: { placeholder: '请选择单位', filterable: true, clearable: true },
          formItemAttributes: {
            label: '单位',
            prop: 'goodsStockUnit',
            rules: [...required]
          },
          events: {
            change: val => {
              this.$refs.formRef.validateField(['goodsStockUnit'], (valid, invalidFields, errLabels) => {})
            }
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '商品代码',
            prop: 'goodsCode',
            rules: []
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '规格型号',
            prop: 'goodsSpecification',
            rules: []
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入', type: 'number' },
          formItemAttributes: {
            label: '销售价格',
            prop: 'marketPrice',
            rules: [...required]
          }
        },
        {
          md: 24,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入', type: 'textarea' },
          formItemAttributes: {
            label: '备注',
            prop: 'remark',
            rules: []
          }
        }
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: websitGoodsAloneMList,
    // 列表导出函数
    exportList: websitGoodsAloneMListExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },

    operation() {
      return this.operationBtn({
        edit: {
          click: ({ row, index, column }) => {
            this.openForm('edit', row.goodsId)
          }
        }
      })
    },
    openForm(type, id) {
      this.$refs.tabPage.addTab({
        // 对应显示的模块
        activeKey: type,
        // 唯一标识
        key: type,
        // 页签名称
        label: { edit: '编辑', add: '新增' }[type],
        // 打开时事件
        triggerEvent: () => {
          this.formCancel()
          this.$nextTick(() => {
            this.formType = type
            this.formVisible = true
            getTypeList({
              pageNum: 1,
              pageSize: -1,
              params: [
                { param: 'a.dict_type', compare: '=', value: `ASSIST_UNIT` },
                { param: 'a.status', compare: '=', value: 'ON' }
              ]
            }).then(res1 => {
              this.partsUnitList = res1.data.records
              this.formDialog = true
            })
            if (type == 'add') {
              this.formDialogType = 0
            } else if (type == 'edit') {
              this.formDialogType = 1
              websitGoodsAloneDetail({ id }).then(res => {
                Object.assign(this.formData, res.data)
              })
            }
          })
        },
        // 关闭时事件
        closeEvent: () => {
          this.formCancel()
        }
      })
    },
    formCancel() {
      this.formVisible = false
      this.$refs?.formRef?.resetFields()
      this.$data.formData = this.$options.data().formData
    },
    formConfirm(cancel) {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ;[websitGoodsAloneAdd, websitGoodsAloneEdit]
            [this.formDialogType]({ ...this.formData, goodsType: 'M' })
            .then(res => {
              this.$message({ type: 'success', message: `${this.formDialogTitles[this.formDialogType]}成功!` })
              cancel('list')
              this.$refs.pageRef.refreshList()
            })
        }
      })
    },
    setRowStatus(type) {
      websitGoodsAloneBatchUpdateStatus({
        ids: this.recordSelected.map(item => item.goodsId).join(','),
        stateEnum: type
      }).then(res => {
        this.$message({ type: 'success', message: `设置成功!` })
        this.$refs.pageRef.refreshList()
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
